# Changelog

## 2025-03-20 - 2.3.2 - fix(compileGlobStringObject)
Fix duplicate file outputs in glob pattern processing

- Removed duplicate concatenation of compiled files in compileGlobStringObject
- Ensured unique file paths are used during TypeScript compilation

## 2025-03-20 - 2.3.1 - fix(compiler)
Refactor compiler implementation with consolidated TsBuild class and improved diagnostics handling

- Removed legacy tsbuild.classes.compiler.ts and introduced tsbuild.classes.tsbuild.ts
- Unified compiler options merging, reading tsconfig.json, and diagnostics reporting within the TsBuild class
- Updated exports to reference the new compiler class implementation for backward compatibility

## 2025-03-20 - 2.3.0 - feat(cli)
Add emitcheck command to validate TS file emission without generating output

- Implemented the emitcheck CLI command to allow checking if TypeScript files can be emitted without producing files
- Updated tsbuild.classes.compiler.ts to include the emitCheck function
- Enhanced documentation in readme.md to describe the new emitcheck usage with examples

## 2025-03-17 - 2.2.7 - fix(compiler)
Improve diagnostic checking and error handling in the TypeScript compiler integration

- Added pre-emit diagnostics check to log errors before emitting
- Process exits on encountering pre-emit errors to ensure build correctness
- Enhanced logging for emit diagnostics to aid debugging

## 2025-03-04 - 2.2.6 - fix(package)
Fix repository URL in package.json

- Updated repository URL in package.json to point to the correct Git repository.

## 2025-03-04 - 2.2.5 - fix(package.json)
Update repository URLs in package metadata.

- Corrected the 'bugs.url' and 'homepage' fields with the accurate URLs.

## 2025-03-04 - 2.2.4 - fix(core)
Fix compiler logic to remove duplicate compiled files and improve glob pattern handling.

- Resolved an issue causing duplicate file compilations when using compileGlobStringObject.
- Improved handling of glob patterns to ensure accurate compilation paths.

## 2025-03-04 - 2.2.3 - fix(exports)
Fixed duplicate file compilation in compileGlobStringObject

- Enhanced type safety checks for glob pattern compilation keys.
- Ensured file list transformations include type checks.
- Fixed issue with duplicate compilation results in compileGlobStringObject.

## 2025-01-28 - 2.2.2 - fix(ci)
Remove GitLab CI configuration


## 2025-01-28 - 2.2.1 - fix(core)
Update dependencies to improve stability and performance.

- Updated @git.zone/tspublish from version ^1.7.5 to ^1.9.1.
- Updated @push.rocks/smartfile from version ^11.0.21 to ^11.1.5.
- Updated @push.rocks/smartpromise from version ^4.0.4 to ^4.2.2.
- Updated typescript from version 5.6.3 to 5.7.3.
- Updated @push.rocks/tapbundle from version ^5.0.23 to ^5.5.6.
- Updated @types/node from version ^22.8.7 to ^22.12.0.

## 2024-11-05 - 2.2.0 - feat(cli)
Enhance CLI for TypeScript folder compilation ordering based on rank and predefined rules.

- CLI now supports automatic ordering of TypeScript folders for compilation using tspublish.json based ranking.
- Ensures 'ts_interfaces' and 'ts_shared' are always transpiled first if certain conditions are met.
- Updated TypeScript compilerOptions to support additional path transformations.
- Updated dependencies versions and added '@git.zone/tspublish' in ts/plugins.ts.

## 2024-10-27 - 2.1.85 - fix(compiler)
Improve path handling in compiler options

- Refactored path import in tsbuild.classes.compiler.ts.
- Enhanced mergeCompilerOptions to read paths and baseUrl from tsconfig.json if present.

## 2024-07-22 - 2.1.84 - fix(cli)
Fixed transpilation order issue in tsfolders command

- Corrected the transpilation order so 'ts_shared' is processed before other folders in the 'tsfolders' CLI command.

## 2024-07-21 - 2.1.83 - fix(cli)
Ensure 'ts_shared' folder is compiled first if present

- Added logic to make sure the 'ts_shared' folder is compiled first when running 'tsfolders' command.

## 2024-06-24 - 2.1.82 - fix(core)
Minor improvements and optimizations in core TypeScript compiler integration.

- Updated TypeScript dependency to latest version 5.5.2.
- Enhanced logging in compiler process.
- Improved handling of CLI commands for better flexibility.
- Compiled output directories are now more structured.
- Refactored internal compiler options merge function.

## 2024-06-24 - 2.1.81 - fix(dependencies)
Update dependencies to latest versions

- Upgraded @push.rocks/smartcli from ^4.0.10 to ^4.0.11
- Upgraded @push.rocks/smartfile from ^11.0.14 to ^11.0.21
- Upgraded @push.rocks/smartlog from ^3.0.3 to ^3.0.7
- Upgraded @push.rocks/smartpromise from ^4.0.3 to ^4.0.4
- Upgraded typescript from 5.4.5 to 5.5.2
- Upgraded @git.zone/tsrun from ^1.2.46 to ^1.2.47
- Upgraded @types/node from ^20.12.11 to ^20.14.8

## 2024-05-17 - 2.1.80 - core
Fix multiple core issues.

- Various small fixes and updates to the core functionality.

## 2024-05-17 - 2.1.76 to 2.1.79 - core
Routine core updates and fixes.

- Several minor enhancements and bug fixes.

## 2024-05-14 - 2.1.74 to 2.1.75 - core
General core maintenance updates.

- Core updated to fix minor bugs.

## 2024-05-10 - 2.1.72 to 2.1.73 - core
Minor core updates.

- Improvements and fixes to core components.

## 2024-01-08 - 2.1.70 to 2.1.71 - core
Core functionality enhancements.

- Small fixes and updates in the core.

## 2023-08-26 - 2.1.66 to 2.1.69 - core
Regular core updates and fixes.

- Various updates to improve core functionality.

## 2023-06-03 - 2.1.65 - core
Core maintenance update.

- Fixed issues in core functionality.

## 2022-08-03 - 2.1.63 to 2.1.64 - core
Minor core updates and fixes.

- Updated core functionality with minor fixes.

## 2022-05-25 - 2.1.61 to 2.1.62 - core
Routine core updates.

- Fixed minor bugs in the core.

## 2022-03-24 - 2.1.60 - core
Core functionality update.

- Fixed various minor issues in core.

## 2022-03-18 - 2.1.57 to 2.1.59 - core
Minor core updates and enhancements.

- Updated core components with small fixes.

## 2022-03-15 - 2.1.50 to 2.1.56 - core
Several core bug fixes.

- Fixed various minor issues in the core functionality.

## 2022-03-14 - 2.1.49 - core
Core update.

- Fixed minor bugs in the core.

## 2022-03-12 - 2.1.43 to 2.1.48 - core
General core maintenance updates.

- Core updated to fix minor bugs and improve functionality.

## 2022-03-11 - 2.1.33 to 2.1.42 - core
Core functionality enhancements and fixes.

- Multiple updates to improve core functionality and fix bugs.

## 2022-03-11 - 2.1.29 to 2.1.32 - core
Routine core updates.

- Minor bug fixes and improvements in core functionality.

## 2022-01-19 - 2.1.28 to 2.1.29 - core
Core bug fixes.

- Updated core to address minor issues.

## 2021-10-06 - 2.1.27 - core
Minor core update.

- Fixed core bugs.

## 2021-09-08 - 2.1.26 - core
Core update.

- Fixed minor bugs in the core.

## 2021-08-17 - 2.1.25 - core
Core bug fixes.

- Small updates to improve core functionality.

## 2020-08-11 - 2.1.24 - core
Routine core update.

- Fixed minor bugs in the core.

## 2020-05-14 - 2.1.23 - core
General core updates.

- Fixes to improve core stability.

## 2020-03-13 - 2.1.20 to 2.1.22 - core
Minor core updates.

- Enhancements and fixes for core functionality.

## 2020-03-09 - 2.1.19 - core
Maintenance core update.

- Fixes addressing minor issues in core functionality.

## 2019-08-26 - 2.1.16 to 2.1.17 - core
Routine minor core updates.

- Improvement and fixes within the core functionality.

## 2019-01-27 - 2.1.6 - custom directory compilation
Now picking up TypeScript files correctly.

- Resolved compilation issues with custom directories.

## 2018-12-05 - 2.1.0 to 2.1.1 - core
Minor core updates.

- Small enhancements and fixes applied to core functionality.

## 2018-12-05 - 2.0.22 - cli options
Now support --web for web compilations targeting Google Chrome.

- Added new CLI option for web compilation.

## 2018-07-25 - 2.0.15 to 2.0.19 - various
Multiple fixes across core, dependency, and compiler modules.

- Packagename fix in core.
- Dependency updates.
- Compiler options fixed.
- Initial core updates.
